import { Injectable, HttpException, HttpStatus } from '@nestjs/common';
import { Repository } from "typeorm";
import { InjectRepository } from "@nestjs/typeorm";

import { GameEntity } from './game.entity';
import { CreateGameDTO } from './game.dto';

@Injectable()
export class GameService {
    constructor(@InjectRepository(GameEntity) private userRepository: Repository<GameEntity>){}

    async register(data: CreateGameDTO) {
        const { gameName } = data;
        let game = await this.userRepository.findOne({where: {gameName}});
        if (game) {
            throw new HttpException('Game with this name already exists', HttpStatus.BAD_REQUEST);
        }
        game = await this.userRepository.create(data);
        await this.userRepository.save(game);
        return game.gameObject();
    }

    /*async login(data: UserDTO) {
        const { name, password } = data;
        const user = await this.userRepository.findOne({ where: { name }});
        if (!user || !(await user.comparePassword(password))) {
            throw new HttpException(
                'Invalid username/password',
                HttpStatus.BAD_REQUEST,
            );
        }
        return user.tokenObject();
    }*/
}
